//*****************************************************************************
// FILE NAME:	 miniRSI_Ec.c
// DESCRIPTION:  EtherCAT VAʐM֐
//*****************************************************************************

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <rt.h>
#include <EhApi.h>

#include "EtherCAT_RSI.h"
#include "miniRSI_Ec.h"

WORD	woMiniRsiEcDebugFlag = 0x1000;					// DEBUG\ؑ׸
#define IFPm	if((woMiniRsiEcDebugFlag&0x0001)!=0)	// APIN\
#define IFPi	if((woMiniRsiEcDebugFlag&0x0010)!=0)	// APIڍו\
#define IFPw	if((woMiniRsiEcDebugFlag&0x0100)!=0)	// MXbhڍו\
#define IFPe	if((woMiniRsiEcDebugFlag&0x1000)!=0)	// װ\


#define	EC_NODE_NAME		"NodeA"					// m[h
#define	EC_ALIAS_NO			255						// GCAXԍ
#define EC_MAX_CH			4						// VACH@MAX
#define	MAXCNT				0x01FF					// obt@ő吔-1(Bit0AɃrbgON)
#define EC_RECV_CYC_TIME	100						// MTCNbN^CimsecPʁj
#define EC_PRI_INTTASK		140						// MXbh̃vCIeB


char	ctkminiRSIC[EC_MAX_CH][16] = {"tkminiRSIC0", "tkminiRSIC1", "tkminiRSIC2", "tkminiRSIC3"};		// گ޶۸ޖ

EHHANDLE		mhHandle = 0;						// EtherCAT APIΘbnh
SLAVE_DETAIL	mstSlaveDetail;						// X[uڍ׏
RTHANDLE		semRsRx[EC_MAX_CH];					// MCxgʒmpZ}tH̃nh
static RTHANDLE		thRsInt[EC_MAX_CH];				// Mobt@ĎXbh̃nh
static BYTE			rxbuf[EC_MAX_CH][MAXCNT+1];		// Mobt@
static WORD			rxrqe[EC_MAX_CH] ;				// MTCY
static WORD			rxidx1[EC_MAX_CH];				// Mς݃CfbNX
static WORD			rxidx2[EC_MAX_CH];				// ǂݍ݃CfbNX
static DWORD		mdwEcStartFlg = 0;				// EtherCATI[vtOi0FI[vA1FI[vj

/* Mf[^TCY̎擾 */
#define	GetRxQueSize(x)	((MAXCNT)&(rxidx1[x]-rxidx2[x]))
#define	UpRxIdx1(x)	((MAXCNT)&(1+rxidx1[x]))
#define	UpRxIdx2(x)	((MAXCNT)&(1+rxidx2[x]))

// {[[ge[u
static struct tagBaudTable{
    DWORD		dwRate;							// {[[g
	BYTE		byWData;						// VA|[gɏo͂f[^l
}BAUDTable[] = {
    {   1200, 0x00 },
    {   2400, 0x01 },
    {   4800, 0x02 },
    {   9600, 0x03 },
    {  19200, 0x04 },
    {  38400, 0x05 },
    {  57600, 0x06 },
    { 115200, 0x07 },
    {      0, 0x00 }
};


// printf
void printf_(const char *fmt, ...)
{
	int		n = 0;
	va_list ap;
	char	buf[1024];

	va_start(ap, fmt);
	n = vsprintf( buf, fmt, ap );
	va_end(ap);

	printf("%s", buf);
}

void Tiny_RSdebug_info()
{
	printf_("I$ miniRSI_Ec[%04d] Tiny_RSdebug_info() CALL!! \n", __LINE__);
	printf_(" req size    [%04d][%04d][%04d][%04d] \n", rxrqe[0], rxrqe[1], rxrqe[2], rxrqe[3]);
	printf_(" write point [%04d][%04d][%04d][%04d] \n", rxidx1[0], rxidx1[1], rxidx1[2], rxidx1[3]);
	printf_(" read point  [%04d][%04d][%04d][%04d] \n", rxidx2[0], rxidx2[1], rxidx2[2], rxidx2[3]);
	printf_(" in offset   [%08xh] \n", mstSlaveDetail.dwViosInBaseOffset);
	printf_(" out offset  [%08xh] \n", mstSlaveDetail.dwViosOutBaseOffset);
}

// ----------------------------------------------------------------------------
// @@\F	EtherCATʐMJnAAPIΘbJ
// @́F	Ȃ
// o@́F	sʁi0FA0ȊOFG[j
// ----------------------------------------------------------------------------
int	Tiny_RSEhOpen()
{
	WORD		woSt;

	IFPm printf_("I$ miniRSI_Ec[%04d] RSEhOpen() CALL!! \n", __LINE__);

	// łAPIΘbJݍς݂̏ꍇAȂɂɏ𔲂
	if( mhHandle != 0 ){
		return( 0 );
	}

	// EtherCATʐMJnAAPIΘbJ
	mhHandle = EhOpen(EC_NODE_NAME, &woSt);
	if( (woSt != ER_EHAPI_OK) && (woSt != ER_EHAPI_OPENED) ) {	// s
		IFPe printf_("E$ miniRSI_Ec[%04d] EhOpen() Err[%04xh] \n", __LINE__, woSt);
		return( -1 );
	}

	return( 0 );
}

// ----------------------------------------------------------------------------
// @@\F	EtherCATʐMIAAPIΘb
// @́F	Ȃ
// o@́F	sʁi0FA0ȊOFG[j
// ----------------------------------------------------------------------------
int	Tiny_RSEhClose()
{
	WORD		woSt;

	IFPm printf_("I$ miniRSI_Ec[%04d] RSEhClose() CALL!! \n", __LINE__);

	// łAPIΘbς݂̏ꍇAȂɂɏ𔲂
	if( mhHandle == 0 ){
		return( 0 );
	}

	// EtherCATʐMIAAPIΘb
	woSt = EhClose( mhHandle );
	if( woSt != ER_EHAPI_OK ){		// s
		IFPe printf_("E$ miniRSI_Ec[%04d] EhClose() Err[%04xh] \n", __LINE__, woSt);
		return( -1 );
	}
	mhHandle = 0;

	return( 0 );
}

// ----------------------------------------------------------------------------
// @@\F	}X^[Xe[g̕ύXv
// @́F	WORD		woState			(i)ύX}X^[Xe[gw
// o@́F	sʁi0FA0ȊOFG[j
// ----------------------------------------------------------------------------
int	Tyny_RSEhRqState( WORD woState )
{
	WORD		woSt;

	IFPm printf_("I$ miniRSI_Ec[%04d] RSEhRqState() CALL!! \n", __LINE__);

	// APIΘbJ݂ĂȂꍇAG[
	if( mhHandle == 0 ){
		return( -1 );
	}

	// }X^[Xe[g̕ύXv
	woSt = EhRqState( mhHandle, woState );
	if( woSt != ER_EHAPI_OK ){		// s
		IFPe printf_("E$ miniRSI_Ec[%04d] EhRqState() Err[%04xh] \n", __LINE__, woSt);
		return( -2 );
	}

	return( 0 );
}



// ----------------------------------------------------------------------------
// @@\F	Mobt@ĎXbh
// @́F	int*		pID			(i)chԍi0`3j
// ----------------------------------------------------------------------------
void far Tiny_RS_IntThread( int* pID )
{
	WORD		woRSize;		// Mobt@f[^TCY
	WORD		woSt;
	DWORD		i;
	WORD		woRpos;			// }X^̎MRead|C^
	WORD		woWpos;			// X[u̎MWrite|C^
	BYTE		byCode;			// Mobt@擾f[^
	WORD		woData;			// o̓f[^
	int			nID;

	nID = *pID;

	// XbhJ^OAs͖
	Catalog(NULL_RTHANDLE, GetRtThreadHandles(THIS_THREAD), ctkminiRSIC[nID]);

	while( 1 ){
		// Mobt@ĎX[v
		RtSleepEx(EC_RECV_CYC_TIME);

		// Mobt@f[^TCY擾
		woRSize = EhReadWord( mhHandle, mstSlaveDetail.dwViosInBaseOffset + (4 + (6 * nID)), &woSt );
		if( ER_EHAPI_OK != woSt ){
			IFPe printf_("E$ miniRSI_Ec[%04d] RS_IntThread(%d) EhReadWord() Err[%04xh] \n", __LINE__, nID, woSt);
			continue;
		}

		// Mobt@Ƀf[^܂ĂȂȂ烋[vɖ߂
		if( woRSize == 0 ){
			continue;
		}

		// -----------------------------------------------------------------------------------------------------
		// Mobt@ɂ܂Ăf[^[v
		for(i=0; i<woRSize; i++){

			// }X^̎MRead|C^擾
			woRpos = EhReadbackWord( mhHandle, mstSlaveDetail.dwViosOutBaseOffset + (2 + (4 * nID)), &woSt );
			if( ER_EHAPI_OK != woSt ){
				IFPe printf_("E$ miniRSI_Ec[%04d] RS_IntThread(%d) EhReadbackWord() Err[%04xh] \n", __LINE__, nID, woSt);
				break;
			}

			// X[u̎MWrite|C^擾
			woWpos = EhReadWord( mhHandle, mstSlaveDetail.dwViosInBaseOffset + (26 + (4 * nID)), &woSt );
			if( ER_EHAPI_OK != woSt ){
				IFPe printf_("E$ miniRSI_Ec[%04d] RS_IntThread(%d) EhReadWord() Err[%04xh] \n", __LINE__, nID, woSt);
				break;
			}

			// ǂݍ݈ʒuƏ݈ʒuvꍇAǂݍރf[^ȂȂƔf𔲂
			if( woRpos == woWpos ){
				break;
			}

			// Mobt@Mf[^擾
			byCode = EhReadByte( mhHandle, mstSlaveDetail.dwViosInBaseOffset + (40 + (32 * nID)) + woRpos, &woSt );
			if( ER_EHAPI_OK != woSt ){
				IFPe printf_("E$ miniRSI_Ec[%04d] RS_IntThread(%d) EhReadByte() Err[%04xh] \n", __LINE__, nID, woSt);
				break;
			}
			
			// Mf[^L[̋󂫂Ίi[
			if( GetRxQueSize(nID) < (sizeof(rxbuf[nID])-1) ){
				rxbuf[nID][rxidx1[nID]] = byCode;
				rxidx1[nID] = UpRxIdx1(nID);		// JEg1XViTCNbNj
			}

			// }X^̎MRead|C^1XV
			woData = (BYTE)(woRpos + 1);
			if( woData >= 32 ){		// I_܂ł擪ʒuɖ߂
				woData = 0;	
			}

			// }X^̎MRead|C^XV
			woSt  = EhWriteWord( mhHandle, mstSlaveDetail.dwViosOutBaseOffset + (2 + (4 * nID)), woData );
			if( ER_EHAPI_OK != woSt ){
				IFPe printf_("E$ miniRSI_Ec[%04d] RS_IntThread(%d) EhWriteWord() Err[%04xh] \n", __LINE__, nID, woSt);
				break;
			}

		}
		// -----------------------------------------------------------------------------------------------------

		/* M\ɂȂCxg */
		if( (GetRxQueSize(nID) >= rxrqe[nID] ) && ( rxrqe[nID] != 0 )){
			IFPw printf_("I$ miniRSI_Ec[%04d] RS_IntThread() ID[%d] %d=(rxidx1-rxidx2) rxrqe=%d rxidx2=%d rxidx1=%d \n", __LINE__,
						nID, GetRxQueSize(nID), rxrqe[nID], rxidx2[nID], rxidx1[nID]);

			rxrqe[nID]	= 0;
			ReleaseRtSemaphore( semRsRx[nID] ,1 );
		}else {
			IFPw printf_("I$ miniRSI_Ec[%04d] RS_IntThread() ID[%d] %d=(rxidx1-rxidx2) rxrqe=%d rxidx2=%d rxidx1=%d \n", __LINE__,
						nID, GetRxQueSize(nID), rxrqe[nID], rxidx2[nID], rxidx1[nID]);
		}

	}

}

// ----------------------------------------------------------------------------
// @@\F	֐
// @́F	int			nID			(i)chԍi0`3j
//			int			nBaudRate	(i){[[gw(1200,2400,4800,9600,c,115200)
//			BYTE		cCommFlags	(i)f[^AXgbvrbgApeBrbgŎw
//										peBȂ		0x00
//										peB		0x18
//										peB		0x08
//										Xgbvrbg1bit	0x00
//										Xgbvrbg2bit	0x04
//										f[^7bit		0x02
//										f[^8bit		0x03
// o@́F	sʁi0FA0ȊOFG[j
// ----------------------------------------------------------------------------
int Tiny_RSinit(int nID, int nBaudRate, BYTE cCommFlags)
{
	WORD		woSt;
	BYTE		byData;
	WORD		woData;
	WORD		woBaudIndex;

	IFPm printf_("I$ miniRSI_Ec[%04d] RSinit(%d) CALL!! BaudRate[%d] CommFlags[%02xh] \n", __LINE__, nID, nBaudRate, cCommFlags);

	// APIΘbJ݂ĂȂꍇAG[
	if( mhHandle == 0 ){
		IFPe printf_("E$ miniRSI_Ec[%04d] RSinit(%d) EherCAT API Handle nothing \n", __LINE__, nID);
		return( -1 );
	}

	// X[uڍ׏擾ĂȂꍇ
	if( mdwEcStartFlg == 0 ){
		mstSlaveDetail.woAlias = EC_ALIAS_NO;						// 擾X[ũGCAXԍZbg
		woSt = EhFindSlaveByAlias( mhHandle, &mstSlaveDetail );		// X[uڍ׏擾܂B
		if( ER_EHAPI_OK != woSt ){
			IFPe printf_("E$ miniRSI_Ec[%04d] RSinit(%d) EhFindSlaveByAlias() Err[%04xh] \n", __LINE__, nID, woSt);
			return( -2 );
		}

		mdwEcStartFlg = 1;
	}

	// w肳ꂽch͈̔̓`FbN
	if( (nID < 0) || (nID >= EC_MAX_CH) ){
		// ͈͊ȌꍇAG[
		IFPe printf_("E$ miniRSI_Ec[%04d] RSinit(%d) ID range error \n", __LINE__, nID);
		return( -3 );
	}

	// w肳ꂽ{[[gLǂ
	woBaudIndex = 0;
	while(TRUE)	{
		// {[[ge[u̍Ō܂ŌAv{[[gȂꍇAG[
		if (BAUDTable[woBaudIndex].dwRate == 0) {
			IFPe printf_("E$ miniRSI_Ec[%04d] RSinit(%d) BaudRate(%d) nothing \n", __LINE__, nBaudRate);
			return( -4 );
		}

		// {[[ge[uY{[[gꍇALƔ
		if (BAUDTable[woBaudIndex].dwRate == (DWORD)nBaudRate) {
			break;
		}

		woBaudIndex ++;
	}

	// ʐM^Cv̐ݒ
	byData = 0;			// ʐM^Cv(0FRS232C or RS422A1FRS485)
	woSt = EhWriteOD( mhHandle, (WORD)mstSlaveDetail.dwSlaveNo, 0x8000 + nID, 0x01, &byData, 1);
	if( ER_EHAPI_OK != woSt ){
		IFPe printf_("E$ miniRSI_Ec[%04d] RSinit(%d) EhWriteOD() Err[%04xh] \n", __LINE__, nID, woSt);
		return( -5 );
	}

	// {[[g̐ݒ
	byData = BAUDTable[woBaudIndex].byWData;
	woSt = EhWriteOD( mhHandle, (WORD)mstSlaveDetail.dwSlaveNo, 0x8000 + nID, 0x03, &byData, 1);
	if( ER_EHAPI_OK != woSt ){
		IFPe printf_("E$ miniRSI_Ec[%04d] RSinit(%d) EhWriteOD() Err[%04xh] \n", __LINE__, nID, woSt);
		return( -6 );
	}

	// f[^̐ݒ
	if( (cCommFlags & DATABIT_EIGHT) == DATABIT_EIGHT ){
		byData = 1;		// f[^ 8bit
	}else {
		byData = 0;		// f[^ 7bit
	}

	woSt = EhWriteOD( mhHandle, (WORD)mstSlaveDetail.dwSlaveNo, 0x8000 + nID, 0x04, &byData, 1);
	if( ER_EHAPI_OK != woSt ){
		IFPe printf_("E$ miniRSI_Ec[%04d] RSinit(%d) EhWriteOD() Err[%04xh] \n", __LINE__, nID, woSt);
		return( -7 );
	}

	// Xgbvrbg̐ݒ
	if( (cCommFlags & STOPBIT_TWO) == STOPBIT_TWO ){
		byData = 1;		// Xgbvrbg 2bit
	}else {
		byData = 0;		// Xgbvrbg 1bit
	}

	woSt = EhWriteOD( mhHandle, (WORD)mstSlaveDetail.dwSlaveNo, 0x8000 + nID, 0x05, &byData, 1);
	if( ER_EHAPI_OK != woSt ){
		IFPe printf_("E$ miniRSI_Ec[%04d] RSinit(%d) EhWriteOD() Err[%04xh] \n", __LINE__, nID, woSt);
		return( -8 );
	}

	// peB̐ݒ
	if( (cCommFlags & PARITY_EVEN) == PARITY_EVEN ){
		byData = 1;		// peB@
	}else if( (cCommFlags & PARITY_ODD) == PARITY_ODD ){
		byData = 2;		// peB@
	}else {
		byData = 0;		// peB@Ȃ
	}

	woSt = EhWriteOD( mhHandle, (WORD)mstSlaveDetail.dwSlaveNo, 0x8000 + nID, 0x06, &byData, 1);
	if( ER_EHAPI_OK != woSt ){
		IFPe printf_("E$ miniRSI_Ec[%04d] RSinit(%d) EhWriteOD() Err[%04xh] \n", __LINE__, nID, woSt);
		return( -9 );
	}

	// CTSt[̐ݒ
	byData = 0;			// CTSt[(0FOFFA1FON)
	woSt = EhWriteOD( mhHandle, (WORD)mstSlaveDetail.dwSlaveNo, 0x8000 + nID, 0x07, &byData, 1);
	if( ER_EHAPI_OK != woSt ){
		IFPe printf_("E$ miniRSI_Ec[%04d] RSinit(%d) EhWriteOD() Err[%04xh] \n", __LINE__, nID, woSt);
		return( -10 );
	}

	// RTSt[̐ݒ
	byData = 0;			// RTSt[(0FDisableA1FEnableA2FHandShake)
	woSt = EhWriteOD( mhHandle, (WORD)mstSlaveDetail.dwSlaveNo, 0x8000 + nID, 0x08, &byData, 1);
	if( ER_EHAPI_OK != woSt ){
		IFPe printf_("E$ miniRSI_Ec[%04d] RSinit(%d) EhWriteOD() Err[%04xh] \n", __LINE__, nID, woSt);
		return( -11 );
	}

	// Xon/Xoff o̓t[̐ݒ
	byData = 0;			// Xon/Xoff o̓t[(0FOFFA1FON)
	woSt = EhWriteOD( mhHandle, (WORD)mstSlaveDetail.dwSlaveNo, 0x8000 + nID, 0x09, &byData, 1);
	if( ER_EHAPI_OK != woSt ){
		IFPe printf_("E$ miniRSI_Ec[%04d] RSinit(%d) EhWriteOD() Err[%04xh] \n", __LINE__, nID, woSt);
		return( -12 );
	}

	// Xon/Xoff ̓t[̐ݒ
	byData = 0;			// Xon/Xoff ̓t[(0FOFFA1FON)
	woSt = EhWriteOD( mhHandle, (WORD)mstSlaveDetail.dwSlaveNo, 0x8000 + nID, 0x0A, &byData, 1);
	if( ER_EHAPI_OK != woSt ){
		IFPe printf_("E$ miniRSI_Ec[%04d] RSinit(%d) EhWriteOD() Err[%04xh] \n", __LINE__, nID, woSt);
		return( -13 );
	}

	// Rg[p[^ɒʐMݒo
	woData = 0x0001;	// R}h(0x0001FʐMݒ)
	woSt = EhWriteOD( mhHandle, (WORD)mstSlaveDetail.dwSlaveNo, 0x8100 + nID, 0x01, &woData, 2);
	if( ER_EHAPI_OK != woSt ){
		IFPe printf_("E$ miniRSI_Ec[%04d] RSinit(%d) EhWriteOD() Err[%04xh] \n", __LINE__, nID, woSt);
		return( -14 );
	}

	// |[gI[v
	byData = 1;			// I[vtO(0FOFFA1FON)
	woSt = EhWriteOD( mhHandle, (WORD)mstSlaveDetail.dwSlaveNo, 0x8000 + nID, 0x02, &byData, 1);
	if( ER_EHAPI_OK != woSt ){
		IFPe printf_("E$ miniRSI_Ec[%04d] RSinit(%d) EhWriteOD() Err[%04xh] \n", __LINE__, nID, woSt);
		return( -15 );
	}

	// Mf[^L[̏
	rxrqe[nID]	= 0 ;
	rxidx1[nID] = rxidx2[nID] = 0;

	// MCxgʒmpZ}tH̐
	semRsRx[nID] = CreateRtSemaphore( 0, 1, FIFO_QUEUING );
	if( semRsRx[nID] == BAD_RTHANDLE ){
		IFPe printf_("E$ miniRSI_Ec[%04d] RSinit(%d) CreateRtSemaphore() Err[%04xh] \n", __LINE__, nID, GetLastRtError());
		return( -16 );
	}

	// MXbh𐶐
	thRsInt[nID] = CreateRtThread(EC_PRI_INTTASK, Tiny_RS_IntThread, 1024, &nID);
	if( thRsInt[nID] == BAD_RTHANDLE ){
		IFPe printf_("E$ miniRSI_Ec[%04d] RSinit(%d) CreateRtThread() Err[%04xh] \n", __LINE__, nID, GetLastRtError());
		return( -17 );
	}

	return( 0 );
}

// ----------------------------------------------------------------------------
// @@\F	N[Y֐
// @́F	int			nID			(i)chԍi0`3j
// o@́F	sʁi0FA0ȊOFG[j
// ----------------------------------------------------------------------------
int Tiny_RSterm(int nID)
{
	WORD		woSt;
	BYTE		byData;

	IFPm printf_("I$ miniRSI_Ec[%04d] RSterm(%d) CALL!! \n", __LINE__, nID);

	// APIΘbJ݂ĂȂꍇAG[
	if( mhHandle == 0 ){
		IFPe printf_("E$ miniRSI_Ec[%04d] RSterm(%d) EherCAT API Handle nothing \n", __LINE__, nID);
		return( -1 );
	}

	// w肳ꂽch͈̔̓`FbN
	if( (nID < 0) || (nID >= EC_MAX_CH) ){
		// ͈͊ȌꍇAG[
		IFPe printf_("E$ miniRSI_Ec[%04d] RSterm(%d) ID range error \n", __LINE__, nID);
		return( -2 );
	}

	// |[gN[Y
	byData = 0;			// I[vtO(0FOFFA1FON)
	woSt = EhWriteOD( mhHandle, (WORD)mstSlaveDetail.dwSlaveNo, 0x8000 + nID, 0x02, &byData, 1);
	if( ER_EHAPI_OK != woSt ){
		IFPe printf_("E$ miniRSI_Ec[%04d] RSterm(%d) EhWriteOD() Err[%04xh] \n", __LINE__, nID, woSt);
		return( -3 );
	}

	// MXbh̍폜
	if( FALSE == DeleteRtThread( thRsInt[nID] ) ){
		return( -4 );		// Xbh̍폜Ɏs
	}

	// MCxgʒmpZ}tH̍폜
	if( FALSE == DeleteRtSemaphore( semRsRx[nID] ) ){
		return( -5 );		// Z}tH̍폜Ɏs
	}

	return( 0 );
}

// ----------------------------------------------------------------------------
// @@\F	M֐
// @́F	int			nID			(i)chԍi0`3j
//			void*		buf			(i)Mobt@̃|C^
//			size_t		size		(i)MTCYw
// o@́F	MTCYi0FG[j
// @lF	M֐͖쐬
// ----------------------------------------------------------------------------
int Tiny_RSsend( int nID, void* buf, size_t size )
{
	IFPm printf_("I$ miniRSI_Ec[%04d] RSsend(%d) CALL!! \n", __LINE__, nID);

	// M֐͖쐬AƂ肠w肳ꂽMTCŶ܂ܕԋp
	return( size );
}

// ----------------------------------------------------------------------------
// @@\F	M֐
// @́F	int			nID			(i)chԍi0`3j
//			void*		buf			(o)Mobt@̃|C^
//			size_t		size		(i)MTCYw
//			DWORD		timeout		(i)M^CAEgwiPʁFmsecj
//			BYTE		*lpSts		gp
// o@́F	MTCYi0FG[j
// ----------------------------------------------------------------------------
int Tiny_RSrecv( int nID, void* buf, size_t size, DWORD timeout, BYTE *lpSts )
{
	WORD	lp1;

	IFPm printf_("I$ miniRSI_Ec[%04d] RSrecv(%d) CALL!! \n", __LINE__, nID);

	// w肳ꂽch͈̔̓`FbN
	if( (nID < 0) || (nID >= EC_MAX_CH) ){
		// ͈͊ȌꍇAG[
		IFPe printf_("E$ miniRSI_Ec[%04d] RSrecv(%d) ID range error \n", __LINE__, nID);
		return( -1 );
	}

	// Mobt@̃|C^w肳ĂȂꍇAG[
	if( buf == NULL ){
		IFPe printf_("E$ miniRSI_Ec[%04d] RSrecv(%d) *buf null error \n", __LINE__, nID);
		return( -2 );
	}

	// w肳ꂽMTCY͈̔̓`FbN
	if(( size >= sizeof(rxbuf[nID]) ) || ( size == 0 )) {
		IFPe printf_("E$ miniRSI_Ec[%04d] RSrecv(ID=%d, SIZE=%d) \n", __LINE__, nID, size );
		return( -3 );
	}
	
	if( GetRxQueSize(nID) >= (WORD)size ){
		// Mf[^L[ɗ܂Ă̂Ŏô
		for( lp1=0 ;lp1<size ;lp1++ ) {
			*((BYTE*)buf+lp1) = rxbuf[nID][rxidx2[nID]];
			rxidx2[nID] = UpRxIdx2(nID);		// JEg1XViTCNbNj
		}
	}
	else{
		// MCxgʒmpZ}tHǂ݁iO̒ʒmCxgcĂꍇ̂Łj
		WaitForRtSemaphore( semRsRx[nID], 1, NO_WAIT );

		// MvƎM҂
		rxrqe[nID]	= size;
		if( WaitForRtSemaphore( semRsRx[nID] ,1 ,timeout ) == WAIT_FAILED ) {
			IFPe printf_("E$ miniRSI_Ec[%04d] RSrecv(ID=%d, SIZE=%d): TimeOut \n", __LINE__, nID, size );
			return( -4 );
		}

		// Mf[^L[̎o
		for( lp1=0 ;lp1<size ;lp1++ ) {
			*((BYTE*)buf+lp1) = rxbuf[nID][rxidx2[nID]];
			rxidx2[nID] = UpRxIdx2(nID);		// JEg1XViTCNbNj
		}
	}

	return( size );
}

// ----------------------------------------------------------------------------
// @@\F	MNA֐
// @́F	int			nID			(i)chԍi0`3j
// o@́F	sʁi0FA0ȊOFG[j
// ----------------------------------------------------------------------------
int Tiny_RSclear(int nID)
{
	IFPm printf_("I$ miniRSI_Ec[%04d] RSclear(%d) CALL!! \n", __LINE__, nID);

	// w肳ꂽch͈̔̓`FbN
	if( (nID < 0) || (nID >= EC_MAX_CH) ){
		// ͈͊ȌꍇAG[
		IFPe printf_("E$ miniRSI_Ec[%04d] RSclear(%d) ID range error \n", __LINE__, nID);
		return( -1 );
	}

	// Mf[^L[oς݂ɐݒ
	rxidx2[nID] = rxidx1[nID];

	return ( 0 );
}
